/* Exercice no 8 */
 
#include <stdlib.h> /* exit */
#include <stdio.h> /* printf, perror */
#include <unistd.h> /* fork, getpid, getppid */
#include <sys/wait.h> /* wait */

/* Le tableu doit tre termin par 0 */
int nofils[] = {2,3,4,0};

void fork_recursif(int profondeur,int t[])
{
  int i,status;

  for(i=0;i<profondeur;i++)
    putchar('\t');
  printf("%4d<-%4d\n",getppid(),getpid());

  for(i=0; i <t[0];i++)
    {
      switch(fork())
	{
	case -1:
	  perror("fork");
	  exit(EXIT_FAILURE);
	case 0:
	  fork_recursif(profondeur + 1,&t[1]);
	default:
	  break;
	}
    }

  /* On attend la terminaison des fils 
     (pas obligatoire) */
  for(i=0; i <t[0];i++)
    wait(&status);

  exit(EXIT_SUCCESS);
}

int main(void)
{
  fork_recursif(0,nofils);  

  /* Ici on ne revient pas */
  return EXIT_SUCCESS;
}

