#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>

#define NB_FILS 10

void filio(void)
{
  int delai;

  srand(getpid()*time(NULL));
  delai = rand() % 10;
  printf("[%5d] J'ai choisi %d\n", getpid(),delai);

  sleep(delai);
  exit(delai);
}

int main(void)
{
  int i,status;
  pid_t pid;

  for(i=0;i< NB_FILS;i++)
        if(fork() == 0) filio();
  
  for(i=0;i< NB_FILS;i++)
    {
      pid = wait(&status);
      if(WIFEXITED(status)) 
	printf("[%4d] Le fils %d est arriv %d-me\n",
	       getpid(),pid,i+1);
    }
  
  exit(EXIT_SUCCESS);
}
