#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <sys/types.h>
#include <wait.h>
#include <time.h>

int no_fils_a_engendrer; /* Intialis  0 */

int ordre_lineaire(int n)
{
  int code_sortie_du_fils, mon_code_sortie=rand()%128;
  
  printf("[%4d] Mon choix : %d\n",
	 getpid(),mon_code_sortie);

  if(n > 0)
    {
      switch(fork())
	{
	case -1:
	  exit(-1);
	case 0:
	  ordre_lineaire(n-1);
	default:
	  wait(&code_sortie_du_fils);
	}
    }

  if(WIFEXITED(code_sortie_du_fils))
    if(mon_code_sortie < WEXITSTATUS(code_sortie_du_fils))
      mon_code_sortie = WEXITSTATUS(code_sortie_du_fils);

  if(n != no_fils_a_engendrer)
    exit(mon_code_sortie);
  
  return mon_code_sortie;
}

int main(int argc, char *argv[])
{
  srand(time(NULL));

  if(argc != 2)
    {
      fprintf(stderr,"Usage : %s n (entier)",argv[0]);
      return 1;
    }

  no_fils_a_engendrer = atoi(argv[1]);

  printf("Le choix maximum est %d.\n",
	 ordre_lineaire(no_fils_a_engendrer));

  return 0;
}
